﻿Imports System.Data.SqlClient

Public Class clsBarang
    'Barang memiliki beberapa properti,
    'seperti Kode, Nama, Jumlah dan Harga...
    Private KdBarang As String
    Private NmBarang As String
    Private JmBarang As Integer
    Private HrBarang As Double

    'Deklarasikan oBD sebaga Class dari clsDatabase
    Private oBD As New clsDatabase()

    'Properti untuk Kode dari barang dengan tipe String
    Public Property KodeBarang() As String
        'Ambil nilai dari kode barang
        Get
            'Beritahukan kodenya..
            Return KdBarang
        End Get
        'Atur Kode barang dengan kode yang akan diberikan dalam nilai
        'yang terdapat dalam 'value' yang bertipe String
        Set(ByVal value As String)
            'Berikan kode barang dengan kode yang baru yang terdapat dalam nilai 'value'
            KdBarang = value
        End Set

        'Dengan kata lain, Get: Mengambil dan memberitahukan hasilnya (memilih data).
        'Set : Mengambil data yang baru dan menyimpan hasilnya (merubah data).
    End Property

    'Penjelasan di bawah hampir sama dengan penjelasan di atas..
    Public Property NamaBarang() As String
        Get
            Return NmBarang
        End Get
        Set(ByVal value As String)
            NmBarang = value
        End Set
    End Property
    Public Property JumlahBarang() As Integer
        Get
            Return JmBarang
        End Get
        Set(ByVal value As Integer)
            JmBarang = value
        End Set
    End Property
    Public Property HargaBarang() As Double
        Get
            Return HrBarang
        End Get
        Set(ByVal value As Double)
            HrBarang = value
        End Set
    End Property

    'Fungsi untuk memilih data-data barang dari tabel tblBarang dengan kode yang telah ditentukan
    'dari properti KodeBarang
    Public Function Pilih() As Boolean
        'Deklarasikan 'proses' dengan nilai False
        'befungsi untuk memberitahukan apakah suatu proses sukses dijalankan atau tidak.
        Dim proses As Boolean = False
        Try
            Dim odr As SqlDataReader
            Dim ssql As String

            'Jika proses koneksi sukses, maka...
            If oBD.Connect() Then
                'Masukkan perintah yang akan dieksekusi ke dalam variabel ssql
                If KodeBarang = Nothing Then
                    ssql = "select * from tblBarang"
                Else
                    ssql = String.Format("select * from tblBarang WHERE KdBarang='{0}'", KodeBarang)
                End If

                'Eksekusi perintah dari ssql
                odr = oBD.ExecuteSql(ssql)
                'Gunakan Fungsi Read() untuk membaca data yang didapat dari perintah SQL di atas
                'Jika ada data yang terbaca, maka..
                If odr.Read() Then
                    'Masukkan masing2 nilai dari Nama Barang, Jumlah, Harga dari dalam tabel tblBarang
                    'ke dalam variabel NmBarang, JmBarang, HrBarang
                    NmBarang = CStr(odr("NmBarang")) 'Convert ke tipe String
                    JmBarang = CInt(odr("Jumlah")) 'Convert ke tipe Integer
                    HrBarang = CDbl(odr("Harga")) 'Convert ke tipe Double
                    'Proses telah sukses dijalankan, jadikan nilai 'proses' menjadi True
                    proses = True

                End If
                'Tutup koneksi ke database
                oBD.Disconnect()
            Else
                'Jika proses koneksi gagal
                MsgBox("Tidak ada koneksi")
            End If

        Catch
            'Jika terjadi kesalahan selama proses di atas, tampilkan pesan kesalahan
            MsgBox("Terjadi masalah dengan DataBase")
            'Berikan nilai dari variabel 'proses', dalam hal ini masih False
            Return proses

        End Try
        'Kembalikan nilai dari variabel 'proses', True atau False tergantung dari
        'sukses atau tidak proses-proses di atas..
        Return proses

    End Function

    'Fungsi untuk menambah data barang yang baru
    Public Function Tambah() As Boolean

        Dim proses As Boolean = False
        Try
            Dim ODR As SqlDataReader
            Dim ssql As String
            If oBD.Connect() Then
                ssql = String.Format("INSERT INTO tblBarang(KdBarang, NmBarang, Jumlah, Harga)VALUES('{0}','{1}','{2}','{3}')", _
                           KdBarang, _
                           NmBarang, _
                           JmBarang, _
                           HrBarang)
                ODR = oBD.ExecuteSql(ssql)
                If IsNothing(ODR) Then
                    MsgBox("Tidak ada yang dimasukkan")
                Else
                    proses = True

                End If
                oBD.Disconnect()
            End If

        Catch
            MsgBox("Masalah terjadi pada DataBase")
            Return proses

        End Try

        Return proses


    End Function

    'Fungsi untuk menghapus data barang dengan Kode barang yang ditentukan
    Public Function Hapus() As Boolean

        Dim proses As Boolean = False
        Try
            Dim ODR As SqlDataReader
            Dim ssql As String
            If oBD.Connect() Then
                ssql = String.Format("DELETE  FROM tblBarang WHERE KdBarang ='{0}'", _
                           KdBarang)
                ODR = oBD.ExecuteSql(ssql)

                If IsNothing(ODR) Then
                    MsgBox("Tidak ada yang dihapus")
                Else
                    proses = True
                End If
                oBD.Disconnect()
            End If

        Catch
            MsgBox("Masalah terjadi dalam database")
            Return proses

        End Try

        Return proses

    End Function

    'Fungsi untuk mengupdate data barang dengan Kode barang yang telah ditentukan
    Public Function Update() As Boolean

        Dim proses As Boolean = False
        Try
            Dim ODR As SqlDataReader
            Dim ssql As String
            If oBD.Connect() Then
                ssql = String.Format("UPDATE  tblBarang SET NmBarang='{0}',Jumlah='{1}',Harga='{2}' WHERE (KdBarang ='{3}')", _
                           NmBarang, _
                           JmBarang, _
                           HrBarang, _
                           KdBarang)

                ODR = oBD.ExecuteSql(ssql)

                If IsNothing(ODR) Then
                    MsgBox("Tidak ada data yang diUpdate")
                Else
                    proses = True

                End If
                oBD.Disconnect()
            End If

        Catch
            MsgBox("Masalah dengan Database")
            Return proses

        End Try

        Return proses


    End Function
End Class
