﻿'Import Namespace System.Data.SQLClient untuk menggunakan beberapa Class SQLClient
'agar dapat mengakses database SQL Server
Imports System.Data.SqlClient

Public Class clsDatabase
    'Deklarasikan beberapa variabel
    'm_sConnectionString : String koneksi ke database SQL Server
    Private m_sConnectionString As String = ""
    'objConnection : Objek koneksi ke database SQL Server
    Private objConnection As SqlConnection
    Sub New()
        'String koneksi yang diambil dari Namespace Databarang pada property ConnectionString
        'Berfungsi supaya bisa terhubung dengan database server.
        m_sConnectionString = DataBarang.My.Settings.ConnectionString
    End Sub

    Sub New(ByVal sConnectionString As String)
        'Untuk mengganti string koneksi (ConnectionString)
        m_sConnectionString = sConnectionString
    End Sub

    'Fungsi untuk melakukan proses koneksi ke database
    Public Function Connect() As Boolean
        Dim cc As Boolean = False
        Try
            'objConnection sebagai Class SQLConnection
            'dengan menggunakan string koneksi dari m_sConnectionString
            objConnection = New SqlConnection(m_sConnectionString)
            'Buka koneksi ke database dengan menggunakan method Open()
            objConnection.Open()
            'Jika berhasil melakukan koneksi ke database
            'set cc=True
            cc = True
        Catch
            'Jika tidak berhasil melakukan koneksi ke database
            'set cc=False
            cc = False
        End Try
        'Mengembalikan nilai cc, True atau False, tergantung sukses tidaknya koneksi
        Return cc
    End Function

    'Fungsi untuk menutup koneksi ke database
    Public Function Disconnect() As Boolean
        Try
            'Disini method Close() digunakan untuk menutup koneksi
            objConnection.Close()
            'Kosongkan objConnection
            objConnection = Nothing
            'Kembalikan nilai True, jika koneksi telah tertutup
            Return True

        Catch e As Exception 'Sebaliknya....
            'Tampilkan pesan kesalahan yang terjadi
            MsgBox(e.Message())
            'Kembalikan nilai False, jika terjadi masalah dalam menutup koneksi
            Return False
        End Try

    End Function

    'Fungsi mengeksekusi perintah SQL
    '@sSql : berisi perintah-perintah SQL
    'Deklarasikan ExecuteSql sebagai SqlDataReader untuk membaca baris dari database
    Public Function ExecuteSql(ByVal sSql As String) As SqlDataReader
        Try
            'Deklarasikan objCommand sebagai SqlCommand untuk mengeksekusi perintah SQL
            Dim objCommand As SqlCommand
            'Deklarasikan myReader sebagai SqlDataReader
            Dim myReader As SqlDataReader

            'objCommand sebagai SqlCommand dengan perintah SQL diambil dari 'sSql' dan
            'koneksi yang digunakan diambil dari objConnection
            objCommand = New SqlCommand(sSql, objConnection)
            'Eksekusi perintah SQL dari yang terdapat dalam 'sSql'
            'dengan menggunakan ExecuteReader()
            myReader = objCommand.ExecuteReader()
            'Kembalikan nilai myReader
            Return myReader

        Catch e As Exception
            'Jika terjadi kesalahan, tampilkan pesan kesalahannya.
            MsgBox(e.Message())
            Return Nothing
        End Try

    End Function

End Class
